#!/bin/sh

function displayscores {

clear

echo "##########################"
echo "Top scores:"
cat highscores.txt
echo
echo
echo "##########################"
echo "Your scores:"
cat difficulty.txt
echo
echo "##########################"

}

function testquit {

 if [ "x$input" == "xquit" ]
  then 
  displayscores
  exit 0
 fi

 if [ "x$input" == "xexit" ]
  then 
  displayscores
  exit 0
 fi

 if [ "x$input" == "xbye" ]
  then 
  displayscores
  exit 0
 fi

}

function addition {

 difficulty="cat difficulty.txt | grep addition | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 nb1=$RANDOM
 let "nb1 %= $difficulty"
 nb1=$(($nb1 + 1))

 nb2=$RANDOM
 let "nb2 %= $difficulty"
 nb2=$(($nb2 + 1))

 result=$(($nb1 + $nb2))

 echo "$nb1 + $nb2 = ?"

 read input

 testquit

 if (($input == $result))
  then
   difficulty=$(($difficulty + 1))
   sed -i -e "s/addition=.*/addition=$difficulty/g" difficulty.txt
   echo Good !
 fi

 if (($input != $result)) && (( $difficulty <= 1 ))
  then
   echo Ahem !
   echo "The good result is $result !"
 fi

 if (($input != $result)) && (( $difficulty > 1 ))
  then
   difficulty=$(($difficulty - 1))
   sed -i -e "s/addition=.*/addition=$difficulty/g" difficulty.txt
   echo Boohoohoo !
   echo "The good result is $result !"
 fi

}

function substraction {

 difficulty="cat difficulty.txt | grep substraction | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 nb1=$RANDOM
 let "nb1 %= $difficulty"
 nb1=$(($nb1 + 1))

 nb2=$RANDOM
 let "nb2 %= $difficulty"
 nb2=$(($nb2 + 1))

 result=$(($nb1 - $nb2))

 echo "$nb1 - $nb2 = ?"

 read input

 testquit

 if (($input == $result))
  then
   difficulty=$(($difficulty + 1))
   sed -i -e "s/substraction=.*/substraction=$difficulty/g" difficulty.txt
   echo Good !
 fi

 if (($input != $result)) && (( $difficulty <= 1 ))
  then
   echo Ahem !
   echo "The good result is $result !"
 fi

 if (($input != $result)) && (( $difficulty > 1 ))
  then
   difficulty=$(($difficulty - 1))
   sed -i -e "s/substraction=.*/substraction=$difficulty/g" difficulty.txt
   echo Boohoohoo !
   echo "The good result is $result !"
 fi

}

function multiplication {

 difficulty="cat difficulty.txt | grep multiplication | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 nb1=$RANDOM
 let "nb1 %= $difficulty"
 nb1=$(($nb1 + 1))

 nb2=$RANDOM
 let "nb2 %= $difficulty"
 nb2=$(($nb2 + 1))

 result=$(($nb1 * $nb2))

 echo "$nb1 X $nb2 = ?"

 read input

 testquit

 if (($input == $result))
  then
   difficulty=$(($difficulty + 1))
   sed -i -e "s/multiplication=.*/multiplication=$difficulty/g" difficulty.txt
   echo Good !
 fi

 if (($input != $result)) && (( $difficulty <= 1 ))
  then
   echo Ahem !
   echo "The good result is $result !"
 fi

 if (($input != $result)) && (( $difficulty > 1 ))
  then
   difficulty=$(($difficulty - 1))
   sed -i -e "s/multiplication=.*/multiplication=$difficulty/g" difficulty.txt
   echo Boohoohoo !
   echo "The good result is $result !"
 fi

}

function division {
echo
}

function mixed {
echo
}

clear

#Splash Screen
echo "Welcome to EvalMaster 1.0 !"
echo "A GPLV3 bash program by Linux-SWAT !"
echo ""
echo "Story:"
echo "Your computer has a failure !!!"
echo "Now it's HIM who asks YOU to compute !!!"
echo ""
echo "----------------------------------------------"
echo "Type exit, quit or bye to stop this program."
echo "----------------------------------------------"
echo ""
echo "----------------------------------------------"
echo "Please push [ENTER] to help your confused CPU."
echo "Gg, hf gl !!!"
echo "----------------------------------------------"

read input

 if [ "x$input" == "xquit" ]
  then 
  exit 0
 fi

 if [ "x$input" == "xexit" ]
  then 
  exit 0
 fi

 if [ "x$input" == "xbye" ]
  then 
  exit 0
 fi

clear

#Choose the game mode
echo "----------------------------------------------"
echo "Current difficulty level:"
echo "----------------------------------------------"
cat difficulty.txt
echo ""
echo "----------------------------------------------"
echo "Choose your computation:"
echo "1 addition"
echo "2 substraction"
echo "3 multiplication"
echo "4 division"
echo "5 mixed"
echo "----------------------------------------------"

while read input; do

 testquit

 if [ "x$input" == "x1" ]
  then 
   compute=add
  break
 fi

 if [ "x$input" == "x2" ]
  then 
   compute=sub
  break
 fi

 if [ "x$input" == "x3" ]
  then 
   compute=mul
  break
 fi

 if [ "x$input" == "x4" ]
  then 
   compute=div
  break
 fi

 if [ "x$input" == "x5" ]
  then 
   compute=mix
  break
 fi

done

case $compute in
    add )
        while true; do addition; done ;;
    sub )
        while true; do substraction; done ;;
    mul )
        while true; do multiplication; done ;;
    div )
        echo "not implemented yet" ;;
    mix )
        echo "not implemented yet" ;;
esac


